	LIST	p=p16f628
	#include <P16F628.inc>	
	LIST
			

	__CONFIG _MCLRE_OFF & _WDT_OFF  & _INTRC_OSC_NOCLKOUT & _LVP_OFF & _PWRTE_ON & _BODEN_ON	

;PORT A ()
bCLK	EQU	3	;RA3, . 2
bDI	EQU	2	;RA2, . 1
;
mIND	EQU	(1<<bCLK)+(1<<bDI)
; PSF
bNewA	EQU	0
	CBLOCK	H'20'
		PSF
		Temp
		Temp1
		A100
		A10
		A1
		RCVD
		W_save
		ST_save
		Del1
		Del2
	endc
	
	goto START
	
	ORG 4
INTSERV				; 
	movwf	W_save		; W
	movf	STATUS,w	; 
	movwf	ST_save
	movf	A10,w		;   :
	movwf	A100		;A10  A100,
	movf	A1,w
	movwf	A10		;A1  A10,
	movf	RCVD,w
	movwf	A1		;RCVD  A1
	movf	RCREG,w		; RCREG  RCVD
	movwf	RCVD		
	movf	ST_save,w	; 
	movwf	STATUS
	movf	W_save,w
	retfie
;------------------------					
	
START	clrf	PORTA
	movlw	7
	movwf	CMCON
	clrf	RCSTA
	bsf	RCSTA,SPEN	; USART; 	
	bsf	STATUS,RP0
	movlw	.15
	movwf	TRISB	
	clrf	TXSTA
	bcf	TXSTA,BRGH	;F/64
	movlw	.51		; 1200
	movwf	SPBRG
	movlw	~mIND
	movwf	TRISA		;  
	bsf 	TXSTA,TXEN
	bcf	STATUS,RP0
	bsf	RCSTA,CREN
	bsf	STATUS,RP0	; :
	bsf	PIE1,RCIE	; ,
	bcf	STATUS,RP0
	bsf	INTCON,PEIE	;  ,
	bsf	INTCON,GIE	; 
;
Loop	bsf	PORTA,bCLK
	bsf	PORTA,bDI
WT	movlw	0x0D		;  
	xorwf	RCVD,w
	btfss	STATUS,Z
	goto	WT
	clrf	RCVD		;   
	call	DD
	bcf	PORTA,bDI
	call 	DD
	movlw	.40		; 
	movwf	Temp
ClrInd	bcf	PORTA,bCLK	
	call	DD
	nop
	bsf	PORTA,bCLK
	nop
	nop
	decfsz	Temp,f
	goto	ClrInd		
	bsf	PORTA,bDI
	movf	A100,w		;  
	call SENDBYTE
	movf	A10,w		;  
	call SENDBYTE
	movf	A1,w		;  
	call SENDBYTE
	goto	Loop
;------------------------------------		
sendbit macro N
	local	S,S0
	btfss	Temp1,N
	goto	S0
	bsf	PORTA,bDI		
	goto	S
S0	bcf	PORTA,bDI
S	call	DD
	bcf	PORTA,bCLK
	call	DD
	bsf	PORTA,bCLK
	endm
SENDBYTE
	andlw	0x0F
	btfsc	STATUS,Z
	movlw	.10
	movwf	Temp1
	sendbit	3
	sendbit 2
	sendbit 1
	sendbit 0
	nop
	nop
	nop
	nop
	return

DD	
	nop	; NOP- 
	nop	;   
	nop	;
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	return
	

	end
